#include <cpu_def.h>
#include <system_def.h>
#include <string.h>
#include <mx1_reg.h>

#define NUM2ASM(sym,val) \
    __asm__ ( \
        ".set " #sym ",%c0\n" \
        ".global " #sym "\n" \
        : :"n"(val) \
    )

/* offset of structure field */
#define OFFSETOF(_type,_member) \
                ((int)&(((_type*)0)->_member))

#define STRUCTFIELD2ASM(_struc,_member) \
        NUM2ASM(_structfield2asm_##_struc##_member,OFFSETOF(struct _struc,_member)); \
        NUM2ASM(_size2asm_##_struc##_member,sizeof(((struct _struc*)0L)->_member))

#define MASKBIT2ASM(def_base) \
        NUM2ASM(_num2asm_##def_base##_b,def_base##_b); \
        NUM2ASM(_num2asm_##def_base##_m,def_base##_m)

void periph_public2asm(void)
{

STRUCTFIELD2ASM(mx1_uartx_regs,URXD);
STRUCTFIELD2ASM(mx1_uartx_regs,UTXD);
STRUCTFIELD2ASM(mx1_uartx_regs,UCR1);
STRUCTFIELD2ASM(mx1_uartx_regs,UCR2);
STRUCTFIELD2ASM(mx1_uartx_regs,UCR3);
STRUCTFIELD2ASM(mx1_uartx_regs,UCR4);
STRUCTFIELD2ASM(mx1_uartx_regs,UFCR);
STRUCTFIELD2ASM(mx1_uartx_regs,USR1);
STRUCTFIELD2ASM(mx1_uartx_regs,USR2);
STRUCTFIELD2ASM(mx1_uartx_regs,UESC);
STRUCTFIELD2ASM(mx1_uartx_regs,UTIM);
STRUCTFIELD2ASM(mx1_uartx_regs,UBIR);
STRUCTFIELD2ASM(mx1_uartx_regs,UBMR);
STRUCTFIELD2ASM(mx1_uartx_regs,UBRC);
STRUCTFIELD2ASM(mx1_uartx_regs,UBIPR);
STRUCTFIELD2ASM(mx1_uartx_regs,UBMPR);
STRUCTFIELD2ASM(mx1_uartx_regs,UTS);

}
