/*******************************************************************
  Components for embedded applications builded for
  laboratory and medical instruments firmware  
 
  mx1_usb.h - USB support for DragonBall M9328 MX1 MCU
 
  Copyright (C) 2002 Roman Bartosinski
            (C) 2004 by Pavel Pisa pisa@cmp.felk.cvut.cz
            (C) 2004 by PiKRON Ltd. http://www.pikron.com

 *******************************************************************/

#ifndef _USB_MX1_SUBMODULE_HEADER_FILE_
  #define _USB_MX1_SUBMODULE_HEADER_FILE_

  #include <usb/usb.h>
 
  int usb_mx1_init( usb_device_t *udev) REENTRANT_SIGN;
  
  #ifdef USB_MX1_DIRECT_FNC
    #define USB_MX1_EXPORT_FNC

    #define usb_udev_is_fnc(_M_udev, _M_fnc) (1)

    #define usb_udev_init usb_mx1_init
    #define usb_udev_connect usb_mx1_connect
    #define usb_udev_disconnect usb_mx1_disconnect
    #define usb_udev_ack_setup usb_mx1_ack_setup
    #define usb_udev_ack_control_setup usb_mx1_ack_control_setup
    #define usb_udev_check_events usb_mx1_check_events

    #define usb_udev_stall usb_mx1_stall
    #define usb_udev_read_endpoint usb_mx1_read_endpoint
    #define usb_udev_write_endpoint usb_mx1_write_endpoint

  #endif /*USB_MX1_DIRECT_FNC*/

  #ifdef USB_MX1_EXPORT_FNC

    int usb_mx1_init( usb_device_t *udev);
    int usb_mx1_connect( usb_device_t *udev);
    int usb_mx1_disconnect( usb_device_t *udev);
    void usb_mx1_ack_setup( usb_device_t *udev);
    void usb_mx1_ack_control_setup( usb_device_t *udev);
    int usb_mx1_check_events( usb_device_t *udev);

    void usb_mx1_stall( usb_ep_t *ep);
    int usb_mx1_read_endpoint( usb_ep_t *ep, void *ptr, int size) USB_UDEV_REENTRANT_SIGN;
    int usb_mx1_write_endpoint( usb_ep_t *ep, const void *ptr, int size) USB_UDEV_REENTRANT_SIGN;

  #endif /*USB_MX1_EXPORT_FNC*/

#endif /* _USB_MX1_SUBMODULE_HEADER_FILE_ */

